//
//  MemoryViewer.m
//
//  Created by Hirano Tetsuya on 11/07/29.
//  Copyright 2011 Hirano-Dept.com. All rights reserved.
//

#import "MemoryViewer.h"
#include <mach/host_info.h>
#include <mach/mach_init.h>
#include <mach/mach_host.h>


@interface MemoryViewer(Private)
-(void)setUI;
@end



@implementation MemoryViewer

#define TIME_INTERVAL 1.0

//MBで返す
-(float)freeSize
{
	struct vm_statistics a_vm_info;
    mach_msg_type_number_t a_count = HOST_VM_INFO_COUNT;
    host_statistics( mach_host_self(), HOST_VM_INFO, (host_info_t)&a_vm_info ,&a_count);
	
	return ((a_vm_info.free_count * vm_page_size)/1024.0)/1024.0;
}


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
		[self setUI];
    }
	self.backgroundColor = [UIColor clearColor];
	
    return self;
}


#pragma mark -
-(void)update
{
	memorylabel.text = [NSString stringWithFormat:@"free memory: %.1f MB",[self freeSize]];
}


-(void)setUI
{
	memorylabel = [[UILabel alloc]initWithFrame:CGRectMake(0.0, 0.0 , self.frame.size.width, self.frame.size.height)];
	memorylabel.backgroundColor = [UIColor clearColor];
	memorylabel.textColor = [UIColor whiteColor];
	memorylabel.shadowColor = [UIColor blackColor];
	memorylabel.shadowOffset = CGSizeMake(2.0, 2.0);
	memorylabel.font = [UIFont systemFontOfSize:12.0];
	[self addSubview:memorylabel];
	[memorylabel release];
	[self update];
	
	[self memoryCheckStart];
}


#pragma mark -
#pragma mark タイマー
-(void)memoryCheckStop
{
	if (timer != nil) {
		LOG(@"timer stop");
		[timer invalidate];
		timer = nil;
	}
}


-(void)memoryCheckStart
{
	if (timer == nil) {
		LOG(@"timer start");
		timer = [NSTimer scheduledTimerWithTimeInterval:TIME_INTERVAL
												 target:self
											   selector:@selector(update)
											   userInfo:nil
												repeats:YES];
	}
}

#pragma mark -
- (void)dealloc {
    [super dealloc];
}
@end
